/* -*- C -*- $Id$ */

/******  Code generated by the IX IDL Compiler *******
 * The IX IDL compiler has been developed by Intel Corp. in order
 * to work in conjunction with OMS communication infrastucture and
 * is based on freely available TAO IDL compiler developed by
 * the Center for Distributed Object Computing at
 * Washington University, St. Louis.
 *
 * Information about TAO IDL compiler is available at:
 *                 http://www.cs.wustl.edu/~schmidt/TAO.html
 */

#ifndef _OMS_IDL__IDL_INGRESS_ACE_STUB_C_H_
#define _OMS_IDL__IDL_INGRESS_ACE_STUB_C_H_

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */


#include "ix/asl.h"
#include "ix/ns.h"
#include "ix/ossl.h"
#include "ix/asl/ixbasecc.h"

/**=================================================
 * INCLUDE PRIMITIVE DATATYPE DECLARATIONS 
 *================================================*/



typedef unsigned char tPortConfig_mac[6];
typedef unsigned char tPortConfig_mac_slice;

/**=================================================
 * Helper functions for tPortConfig_mac array 
 *================================================*/

/* Marshaling function for tPortConfig::mac array */
extern ix_error ix_sds_r_tPortConfig_mac (ix_sds aSds, const tPortConfig_mac_slice* val);

/* Demarshaling function for tPortConfig::mac array */
extern ix_error ix_sds_p_tPortConfig_mac (ix_sds aSds, tPortConfig_mac_slice* val);

/* Initialization function for tPortConfig::mac array */
extern ix_error init_tPortConfig_mac (tPortConfig_mac_slice* val);

/* Finalization function for tPortConfig::mac array */
extern ix_error fini_tPortConfig_mac (tPortConfig_mac_slice* val);

/* Release function for tPortConfig::mac array */
extern ix_error release_tPortConfig_mac (tPortConfig_mac_slice* val);

/**=================================================
 * End helper functions for tPortConfig_mac array 
 *================================================*/


typedef struct _s_tPortConfig
{
  long portNum;
  long portType;
  long mtu;
  long cost;
  tPortConfig_mac mac;
  long flags;
} tPortConfig;

/**=================================================
 * Helper functions for tPortConfig structure 
 *================================================*/

/* Marshaling function for tPortConfig structure */
extern ix_error ix_sds_r_tPortConfig (ix_sds aSds, const tPortConfig* val);

/* Demarshaling function for tPortConfig structure */
extern ix_error ix_sds_p_tPortConfig (ix_sds aSds, tPortConfig* val);

/* Initialization function for tPortConfig structure */
extern ix_error init_tPortConfig (tPortConfig* val);

/* Finalization function for tPortConfig structure */
extern ix_error fini_tPortConfig (tPortConfig* val);

/* Release function for tPortConfig structure */
extern ix_error release_tPortConfig (tPortConfig* val);

/**=================================================
 * End helper functions for tPortConfig structure 
 *================================================*/


typedef char tIfConfig_name[128];
typedef char tIfConfig_name_slice;

/**=================================================
 * Helper functions for tIfConfig_name array 
 *================================================*/

/* Marshaling function for tIfConfig::name array */
extern ix_error ix_sds_r_tIfConfig_name (ix_sds aSds, const tIfConfig_name_slice* val);

/* Demarshaling function for tIfConfig::name array */
extern ix_error ix_sds_p_tIfConfig_name (ix_sds aSds, tIfConfig_name_slice* val);

/* Initialization function for tIfConfig::name array */
extern ix_error init_tIfConfig_name (tIfConfig_name_slice* val);

/* Finalization function for tIfConfig::name array */
extern ix_error fini_tIfConfig_name (tIfConfig_name_slice* val);

/* Release function for tIfConfig::name array */
extern ix_error release_tIfConfig_name (tIfConfig_name_slice* val);

/**=================================================
 * End helper functions for tIfConfig_name array 
 *================================================*/


typedef struct _s_tIfConfig
{
  long portNum;
  unsigned long ifNum;
  unsigned long ipV4Addr;
  unsigned long ipV4Mask;
  unsigned long flags;
  tIfConfig_name name;
} tIfConfig;

/**=================================================
 * Helper functions for tIfConfig structure 
 *================================================*/

/* Marshaling function for tIfConfig structure */
extern ix_error ix_sds_r_tIfConfig (ix_sds aSds, const tIfConfig* val);

/* Demarshaling function for tIfConfig structure */
extern ix_error ix_sds_p_tIfConfig (ix_sds aSds, tIfConfig* val);

/* Initialization function for tIfConfig structure */
extern ix_error init_tIfConfig (tIfConfig* val);

/* Finalization function for tIfConfig structure */
extern ix_error fini_tIfConfig (tIfConfig* val);

/* Release function for tIfConfig structure */
extern ix_error release_tIfConfig (tIfConfig* val);

/**=================================================
 * End helper functions for tIfConfig structure 
 *================================================*/


typedef struct _s_tPortSnmpStats
{
  unsigned long rcvdFramesOk;
  unsigned long sentFramesOk;
  unsigned long rcvdBytes;
  unsigned long sentBytes;
  unsigned long sentMCastFrames;
  unsigned long rcvdMCastFrames;
  unsigned long sentBCastFrames;
  unsigned long rcvdBCastFrames;
} tPortSnmpStats;

/**=================================================
 * Helper functions for tPortSnmpStats structure 
 *================================================*/

/* Marshaling function for tPortSnmpStats structure */
extern ix_error ix_sds_r_tPortSnmpStats (ix_sds aSds, const tPortSnmpStats* val);

/* Demarshaling function for tPortSnmpStats structure */
extern ix_error ix_sds_p_tPortSnmpStats (ix_sds aSds, tPortSnmpStats* val);

/* Initialization function for tPortSnmpStats structure */
extern ix_error init_tPortSnmpStats (tPortSnmpStats* val);

/* Finalization function for tPortSnmpStats structure */
extern ix_error fini_tPortSnmpStats (tPortSnmpStats* val);

/* Release function for tPortSnmpStats structure */
extern ix_error release_tPortSnmpStats (tPortSnmpStats* val);

/**=================================================
 * End helper functions for tPortSnmpStats structure 
 *================================================*/


typedef unsigned char tMacAddr_mac[6];
typedef unsigned char tMacAddr_mac_slice;

/**=================================================
 * Helper functions for tMacAddr_mac array 
 *================================================*/

/* Marshaling function for tMacAddr::mac array */
extern ix_error ix_sds_r_tMacAddr_mac (ix_sds aSds, const tMacAddr_mac_slice* val);

/* Demarshaling function for tMacAddr::mac array */
extern ix_error ix_sds_p_tMacAddr_mac (ix_sds aSds, tMacAddr_mac_slice* val);

/* Initialization function for tMacAddr::mac array */
extern ix_error init_tMacAddr_mac (tMacAddr_mac_slice* val);

/* Finalization function for tMacAddr::mac array */
extern ix_error fini_tMacAddr_mac (tMacAddr_mac_slice* val);

/* Release function for tMacAddr::mac array */
extern ix_error release_tMacAddr_mac (tMacAddr_mac_slice* val);

/**=================================================
 * End helper functions for tMacAddr_mac array 
 *================================================*/


typedef struct _s_tMacAddr
{
  tMacAddr_mac mac;
} tMacAddr;

/**=================================================
 * Helper functions for tMacAddr structure 
 *================================================*/

/* Marshaling function for tMacAddr structure */
extern ix_error ix_sds_r_tMacAddr (ix_sds aSds, const tMacAddr* val);

/* Demarshaling function for tMacAddr structure */
extern ix_error ix_sds_p_tMacAddr (ix_sds aSds, tMacAddr* val);

/* Initialization function for tMacAddr structure */
extern ix_error init_tMacAddr (tMacAddr* val);

/* Finalization function for tMacAddr structure */
extern ix_error fini_tMacAddr (tMacAddr* val);

/* Release function for tMacAddr structure */
extern ix_error release_tMacAddr (tMacAddr* val);

/**=================================================
 * End helper functions for tMacAddr structure 
 *================================================*/


#ifndef _ixa_c_seq_tPortConfig_declared
#define _ixa_c_seq_tPortConfig_declared

typedef struct _s_ixa_c_seq_tPortConfig
{
  unsigned long _maximum;
  unsigned long _length;
  unsigned int  _release;
  struct _s_tPortConfig* _buffer;
} ixa_c_seq_tPortConfig;

/**=================================================
 * Helper functions for ixa_c_seq_tPortConfig sequence 
 *================================================*/

/* Marshaling function for ixa_c_seq_tPortConfig sequence */
extern ix_error ix_sds_r_ixa_c_seq_tPortConfig (ix_sds aSds, const ixa_c_seq_tPortConfig* val);

/* Demarshaling function for ixa_c_seq_tPortConfig sequence */
extern ix_error ix_sds_p_ixa_c_seq_tPortConfig (ix_sds aSds, ixa_c_seq_tPortConfig* val);

/* Initialization function for ixa_c_seq_tPortConfig sequence */
extern ix_error init_ixa_c_seq_tPortConfig (ixa_c_seq_tPortConfig* val);

/* Finalization function for ixa_c_seq_tPortConfig sequence */
extern ix_error fini_ixa_c_seq_tPortConfig (ixa_c_seq_tPortConfig* val);

/* Release function for ixa_c_seq_tPortConfig sequence */
extern ix_error release_ixa_c_seq_tPortConfig (ixa_c_seq_tPortConfig* val);

/**=================================================
 * End helper functions for ixa_c_seq_tPortConfig sequence 
 *================================================*/

#endif  /* end define _ixa_c_seq_tPortConfig_declared */

typedef ixa_c_seq_tPortConfig tAPortConfig;


#ifndef _ixa_c_seq_tIfConfig_declared
#define _ixa_c_seq_tIfConfig_declared

typedef struct _s_ixa_c_seq_tIfConfig
{
  unsigned long _maximum;
  unsigned long _length;
  unsigned int  _release;
  struct _s_tIfConfig* _buffer;
} ixa_c_seq_tIfConfig;

/**=================================================
 * Helper functions for ixa_c_seq_tIfConfig sequence 
 *================================================*/

/* Marshaling function for ixa_c_seq_tIfConfig sequence */
extern ix_error ix_sds_r_ixa_c_seq_tIfConfig (ix_sds aSds, const ixa_c_seq_tIfConfig* val);

/* Demarshaling function for ixa_c_seq_tIfConfig sequence */
extern ix_error ix_sds_p_ixa_c_seq_tIfConfig (ix_sds aSds, ixa_c_seq_tIfConfig* val);

/* Initialization function for ixa_c_seq_tIfConfig sequence */
extern ix_error init_ixa_c_seq_tIfConfig (ixa_c_seq_tIfConfig* val);

/* Finalization function for ixa_c_seq_tIfConfig sequence */
extern ix_error fini_ixa_c_seq_tIfConfig (ixa_c_seq_tIfConfig* val);

/* Release function for ixa_c_seq_tIfConfig sequence */
extern ix_error release_ixa_c_seq_tIfConfig (ixa_c_seq_tIfConfig* val);

/**=================================================
 * End helper functions for ixa_c_seq_tIfConfig sequence 
 *================================================*/

#endif  /* end define _ixa_c_seq_tIfConfig_declared */

typedef ixa_c_seq_tIfConfig tAIfConfig;


/**=================================================
 * Start stub declaration of interface portMgmt
 *================================================*/

/* Declare the interface name for portMgmt interface */
extern const char portMgmt_intName[];

/* Declare the local operation names for CC_VMT_portMgmt interface */

/* Declare the name for portMgmt::portGetPorts operation */
extern const char portMgmt_portGetPorts_opName[];

/* Declare the name for portMgmt::portGetConfig operation */
extern const char portMgmt_portGetConfig_opName[];

/* Declare the name for portMgmt::portSetConfig operation */
extern const char portMgmt_portSetConfig_opName[];

/* Declare the name for portMgmt::portEnable operation */
extern const char portMgmt_portEnable_opName[];

/* Declare the name for portMgmt::portDisable operation */
extern const char portMgmt_portDisable_opName[];

/* Declare the name for portMgmt::portGetFlags operation */
extern const char portMgmt_portGetFlags_opName[];

/* Declare the name for portMgmt::portSetFlags operation */
extern const char portMgmt_portSetFlags_opName[];

/* Declare the name for portMgmt::portAddMacAddrFilter operation */
extern const char portMgmt_portAddMacAddrFilter_opName[];

/* Declare the name for portMgmt::portRemoveMacAddrFilter operation */
extern const char portMgmt_portRemoveMacAddrFilter_opName[];

/* Declare the name for portMgmt::portSetMacAddr operation */
extern const char portMgmt_portSetMacAddr_opName[];

/* Declare the name for portMgmt::portGetMacAddr operation */
extern const char portMgmt_portGetMacAddr_opName[];

/* Declare the name for portMgmt::portSetPromiscMode operation */
extern const char portMgmt_portSetPromiscMode_opName[];

/* Declare the name for portMgmt::portClearPromiscMode operation */
extern const char portMgmt_portClearPromiscMode_opName[];

/* Declare the name for portMgmt::portClearStats operation */
extern const char portMgmt_portClearStats_opName[];

/* Declare the name for portMgmt::portGetSnmpStats operation */
extern const char portMgmt_portGetSnmpStats_opName[];


/* Client initialization function for portMgmt interface */
extern ix_error stub_portMgmt_init (ix_base_t* basep, ix_cap *capp);

/* Client finalization function for portMgmt interface */
extern ix_error stub_portMgmt_fini (ix_base_t* basep);

/* Declare the a cross call function pointer type for portMgmt::portGetPorts operation */
typedef ix_error (* portMgmt_portGetPorts_fptr)(ix_base_t* basep, tAPortConfig* ports);

/* Declare the crosscall reference function for portMgmt::portGetPorts operation */
extern ix_error stub_portMgmt_portGetPorts(ix_base_t* basep);

/* Declare the deferred callback function for portMgmt::portGetPorts operation */
extern ix_error deferred_cb_portMgmt_portGetPorts (ix_error anError, void* cookie, ix_sds aSds);

/* Declare the user callback function pointer type for portMgmt::portGetPorts operation */
typedef ix_error (* portMgmt_portGetPorts_cb_fptr)(ix_base_t* basep, ix_error anError, const tAPortConfig* ports);

/* Declare the a cross call function pointer type for portMgmt::portGetConfig operation */
typedef ix_error (* portMgmt_portGetConfig_fptr)(ix_base_t* basep, long portNum, tPortConfig* portConfig);

/* Declare the crosscall reference function for portMgmt::portGetConfig operation */
extern ix_error stub_portMgmt_portGetConfig(ix_base_t* basep, long portNum);

/* Declare the deferred callback function for portMgmt::portGetConfig operation */
extern ix_error deferred_cb_portMgmt_portGetConfig (ix_error anError, void* cookie, ix_sds aSds);

/* Declare the user callback function pointer type for portMgmt::portGetConfig operation */
typedef ix_error (* portMgmt_portGetConfig_cb_fptr)(ix_base_t* basep, ix_error anError, const tPortConfig* portConfig);

/* Declare the a cross call function pointer type for portMgmt::portSetConfig operation */
typedef ix_error (* portMgmt_portSetConfig_fptr)(ix_base_t* basep, long portNum, const tPortConfig* portConfig);

/* Declare the crosscall reference function for portMgmt::portSetConfig operation */
extern ix_error stub_portMgmt_portSetConfig(ix_base_t* basep, long portNum, const tPortConfig* portConfig);

/* Declare the a cross call function pointer type for portMgmt::portEnable operation */
typedef ix_error (* portMgmt_portEnable_fptr)(ix_base_t* basep, long portNum);

/* Declare the crosscall reference function for portMgmt::portEnable operation */
extern ix_error stub_portMgmt_portEnable(ix_base_t* basep, long portNum);

/* Declare the a cross call function pointer type for portMgmt::portDisable operation */
typedef ix_error (* portMgmt_portDisable_fptr)(ix_base_t* basep, long portNum);

/* Declare the crosscall reference function for portMgmt::portDisable operation */
extern ix_error stub_portMgmt_portDisable(ix_base_t* basep, long portNum);

/* Declare the a cross call function pointer type for portMgmt::portGetFlags operation */
typedef ix_error (* portMgmt_portGetFlags_fptr)(ix_base_t* basep, long portNum, unsigned long* flags);

/* Declare the crosscall reference function for portMgmt::portGetFlags operation */
extern ix_error stub_portMgmt_portGetFlags(ix_base_t* basep, long portNum);

/* Declare the deferred callback function for portMgmt::portGetFlags operation */
extern ix_error deferred_cb_portMgmt_portGetFlags (ix_error anError, void* cookie, ix_sds aSds);

/* Declare the user callback function pointer type for portMgmt::portGetFlags operation */
typedef ix_error (* portMgmt_portGetFlags_cb_fptr)(ix_base_t* basep, ix_error anError, unsigned long flags);

/* Declare the a cross call function pointer type for portMgmt::portSetFlags operation */
typedef ix_error (* portMgmt_portSetFlags_fptr)(ix_base_t* basep, long portNum, unsigned long flags);

/* Declare the crosscall reference function for portMgmt::portSetFlags operation */
extern ix_error stub_portMgmt_portSetFlags(ix_base_t* basep, long portNum, unsigned long flags);

/* Declare the a cross call function pointer type for portMgmt::portAddMacAddrFilter operation */
typedef ix_error (* portMgmt_portAddMacAddrFilter_fptr)(ix_base_t* basep, long portNum, const tMacAddr* addr);

/* Declare the crosscall reference function for portMgmt::portAddMacAddrFilter operation */
extern ix_error stub_portMgmt_portAddMacAddrFilter(ix_base_t* basep, long portNum, const tMacAddr* addr);

/* Declare the a cross call function pointer type for portMgmt::portRemoveMacAddrFilter operation */
typedef ix_error (* portMgmt_portRemoveMacAddrFilter_fptr)(ix_base_t* basep, long portNum, const tMacAddr* addr);

/* Declare the crosscall reference function for portMgmt::portRemoveMacAddrFilter operation */
extern ix_error stub_portMgmt_portRemoveMacAddrFilter(ix_base_t* basep, long portNum, const tMacAddr* addr);

/* Declare the a cross call function pointer type for portMgmt::portSetMacAddr operation */
typedef ix_error (* portMgmt_portSetMacAddr_fptr)(ix_base_t* basep, long portNum, const tMacAddr* addr);

/* Declare the crosscall reference function for portMgmt::portSetMacAddr operation */
extern ix_error stub_portMgmt_portSetMacAddr(ix_base_t* basep, long portNum, const tMacAddr* addr);

/* Declare the a cross call function pointer type for portMgmt::portGetMacAddr operation */
typedef ix_error (* portMgmt_portGetMacAddr_fptr)(ix_base_t* basep, long portNum, tMacAddr* addr);

/* Declare the crosscall reference function for portMgmt::portGetMacAddr operation */
extern ix_error stub_portMgmt_portGetMacAddr(ix_base_t* basep, long portNum);

/* Declare the deferred callback function for portMgmt::portGetMacAddr operation */
extern ix_error deferred_cb_portMgmt_portGetMacAddr (ix_error anError, void* cookie, ix_sds aSds);

/* Declare the user callback function pointer type for portMgmt::portGetMacAddr operation */
typedef ix_error (* portMgmt_portGetMacAddr_cb_fptr)(ix_base_t* basep, ix_error anError, const tMacAddr* addr);

/* Declare the a cross call function pointer type for portMgmt::portSetPromiscMode operation */
typedef ix_error (* portMgmt_portSetPromiscMode_fptr)(ix_base_t* basep, long portNum);

/* Declare the crosscall reference function for portMgmt::portSetPromiscMode operation */
extern ix_error stub_portMgmt_portSetPromiscMode(ix_base_t* basep, long portNum);

/* Declare the a cross call function pointer type for portMgmt::portClearPromiscMode operation */
typedef ix_error (* portMgmt_portClearPromiscMode_fptr)(ix_base_t* basep, long portNum);

/* Declare the crosscall reference function for portMgmt::portClearPromiscMode operation */
extern ix_error stub_portMgmt_portClearPromiscMode(ix_base_t* basep, long portNum);

/* Declare the a cross call function pointer type for portMgmt::portClearStats operation */
typedef ix_error (* portMgmt_portClearStats_fptr)(ix_base_t* basep, long portNum);

/* Declare the crosscall reference function for portMgmt::portClearStats operation */
extern ix_error stub_portMgmt_portClearStats(ix_base_t* basep, long portNum);

/* Declare the a cross call function pointer type for portMgmt::portGetSnmpStats operation */
typedef ix_error (* portMgmt_portGetSnmpStats_fptr)(ix_base_t* basep, long portNum, tPortSnmpStats* stats);

/* Declare the crosscall reference function for portMgmt::portGetSnmpStats operation */
extern ix_error stub_portMgmt_portGetSnmpStats(ix_base_t* basep, long portNum);

/* Declare the deferred callback function for portMgmt::portGetSnmpStats operation */
extern ix_error deferred_cb_portMgmt_portGetSnmpStats (ix_error anError, void* cookie, ix_sds aSds);

/* Declare the user callback function pointer type for portMgmt::portGetSnmpStats operation */
typedef ix_error (* portMgmt_portGetSnmpStats_cb_fptr)(ix_base_t* basep, ix_error anError, const tPortSnmpStats* stats);

/* Declare the crosscall VMT structure for portMgmt interface */

/**
 * CC_VMT_portMgmt structure holds function pointers to implementation
 * functions for all local and inherited operations
 */
typedef struct _CC_VMT_portMgmt
{
  portMgmt_portGetPorts_fptr _pCC_portMgmt_portGetPorts;
  portMgmt_portGetConfig_fptr _pCC_portMgmt_portGetConfig;
  portMgmt_portSetConfig_fptr _pCC_portMgmt_portSetConfig;
  portMgmt_portEnable_fptr _pCC_portMgmt_portEnable;
  portMgmt_portDisable_fptr _pCC_portMgmt_portDisable;
  portMgmt_portGetFlags_fptr _pCC_portMgmt_portGetFlags;
  portMgmt_portSetFlags_fptr _pCC_portMgmt_portSetFlags;
  portMgmt_portAddMacAddrFilter_fptr _pCC_portMgmt_portAddMacAddrFilter;
  portMgmt_portRemoveMacAddrFilter_fptr _pCC_portMgmt_portRemoveMacAddrFilter;
  portMgmt_portSetMacAddr_fptr _pCC_portMgmt_portSetMacAddr;
  portMgmt_portGetMacAddr_fptr _pCC_portMgmt_portGetMacAddr;
  portMgmt_portSetPromiscMode_fptr _pCC_portMgmt_portSetPromiscMode;
  portMgmt_portClearPromiscMode_fptr _pCC_portMgmt_portClearPromiscMode;
  portMgmt_portClearStats_fptr _pCC_portMgmt_portClearStats;
  portMgmt_portGetSnmpStats_fptr _pCC_portMgmt_portGetSnmpStats;
} CC_VMT_portMgmt;


/* Declare the callback VMT structure for portMgmt interface */

/**
 * CC_VMT_portMgmt structure holds function pointers to user callback
 * functions for all local and inherited operations
 */
typedef struct _CB_VMT_portMgmt
{
  portMgmt_portGetPorts_cb_fptr _pCB_portMgmt_portGetPorts;
  portMgmt_portGetConfig_cb_fptr _pCB_portMgmt_portGetConfig;
  portMgmt_portGetFlags_cb_fptr _pCB_portMgmt_portGetFlags;
  portMgmt_portGetMacAddr_cb_fptr _pCB_portMgmt_portGetMacAddr;
  portMgmt_portGetSnmpStats_cb_fptr _pCB_portMgmt_portGetSnmpStats;
} CB_VMT_portMgmt;

/* Accessor function for callback VMT */
extern ix_error getCBVMT_portMgmt(const ix_base_t* basep, CB_VMT_portMgmt** pInterfaceCBVMT);

/**=================================================
 * End stub declaration of interface portMgmt
 *================================================*/


/**=================================================
 * Start stub declaration of interface logicalIfMgmt
 *================================================*/

/* Declare the interface name for logicalIfMgmt interface */
extern const char logicalIfMgmt_intName[];

/* Declare the local operation names for CC_VMT_logicalIfMgmt interface */

/* Declare the name for logicalIfMgmt::ifGetIfs operation */
extern const char logicalIfMgmt_ifGetIfs_opName[];

/* Declare the name for logicalIfMgmt::ifGetConfig operation */
extern const char logicalIfMgmt_ifGetConfig_opName[];

/* Declare the name for logicalIfMgmt::ifSetConfig operation */
extern const char logicalIfMgmt_ifSetConfig_opName[];

/* Declare the name for logicalIfMgmt::ifSetFlags operation */
extern const char logicalIfMgmt_ifSetFlags_opName[];

/* Declare the name for logicalIfMgmt::ifGetFlags operation */
extern const char logicalIfMgmt_ifGetFlags_opName[];

/* Declare the name for logicalIfMgmt::ifAddIf operation */
extern const char logicalIfMgmt_ifAddIf_opName[];

/* Declare the name for logicalIfMgmt::ifRemoveIf operation */
extern const char logicalIfMgmt_ifRemoveIf_opName[];


/* Client initialization function for logicalIfMgmt interface */
extern ix_error stub_logicalIfMgmt_init (ix_base_t* basep, ix_cap *capp);

/* Client finalization function for logicalIfMgmt interface */
extern ix_error stub_logicalIfMgmt_fini (ix_base_t* basep);

/* Declare the a cross call function pointer type for logicalIfMgmt::ifGetIfs operation */
typedef ix_error (* logicalIfMgmt_ifGetIfs_fptr)(ix_base_t* basep, long portNum, tAIfConfig* _cxx_if);

/* Declare the crosscall reference function for logicalIfMgmt::ifGetIfs operation */
extern ix_error stub_logicalIfMgmt_ifGetIfs(ix_base_t* basep, long portNum);

/* Declare the deferred callback function for logicalIfMgmt::ifGetIfs operation */
extern ix_error deferred_cb_logicalIfMgmt_ifGetIfs (ix_error anError, void* cookie, ix_sds aSds);

/* Declare the user callback function pointer type for logicalIfMgmt::ifGetIfs operation */
typedef ix_error (* logicalIfMgmt_ifGetIfs_cb_fptr)(ix_base_t* basep, ix_error anError, const tAIfConfig* _cxx_if);

/* Declare the a cross call function pointer type for logicalIfMgmt::ifGetConfig operation */
typedef ix_error (* logicalIfMgmt_ifGetConfig_fptr)(ix_base_t* basep, long portNum, long ifNum, tIfConfig* ifCfg);

/* Declare the crosscall reference function for logicalIfMgmt::ifGetConfig operation */
extern ix_error stub_logicalIfMgmt_ifGetConfig(ix_base_t* basep, long portNum, long ifNum);

/* Declare the deferred callback function for logicalIfMgmt::ifGetConfig operation */
extern ix_error deferred_cb_logicalIfMgmt_ifGetConfig (ix_error anError, void* cookie, ix_sds aSds);

/* Declare the user callback function pointer type for logicalIfMgmt::ifGetConfig operation */
typedef ix_error (* logicalIfMgmt_ifGetConfig_cb_fptr)(ix_base_t* basep, ix_error anError, const tIfConfig* ifCfg);

/* Declare the a cross call function pointer type for logicalIfMgmt::ifSetConfig operation */
typedef ix_error (* logicalIfMgmt_ifSetConfig_fptr)(ix_base_t* basep, long portNum, long ifNum, const tIfConfig* ifCfg);

/* Declare the crosscall reference function for logicalIfMgmt::ifSetConfig operation */
extern ix_error stub_logicalIfMgmt_ifSetConfig(ix_base_t* basep, long portNum, long ifNum, const tIfConfig* ifCfg);

/* Declare the a cross call function pointer type for logicalIfMgmt::ifSetFlags operation */
typedef ix_error (* logicalIfMgmt_ifSetFlags_fptr)(ix_base_t* basep, long portNum, long ifNum, unsigned long flags);

/* Declare the crosscall reference function for logicalIfMgmt::ifSetFlags operation */
extern ix_error stub_logicalIfMgmt_ifSetFlags(ix_base_t* basep, long portNum, long ifNum, unsigned long flags);

/* Declare the a cross call function pointer type for logicalIfMgmt::ifGetFlags operation */
typedef ix_error (* logicalIfMgmt_ifGetFlags_fptr)(ix_base_t* basep, long portNum, long ifNum, unsigned long* flags);

/* Declare the crosscall reference function for logicalIfMgmt::ifGetFlags operation */
extern ix_error stub_logicalIfMgmt_ifGetFlags(ix_base_t* basep, long portNum, long ifNum);

/* Declare the deferred callback function for logicalIfMgmt::ifGetFlags operation */
extern ix_error deferred_cb_logicalIfMgmt_ifGetFlags (ix_error anError, void* cookie, ix_sds aSds);

/* Declare the user callback function pointer type for logicalIfMgmt::ifGetFlags operation */
typedef ix_error (* logicalIfMgmt_ifGetFlags_cb_fptr)(ix_base_t* basep, ix_error anError, unsigned long flags);

/* Declare the a cross call function pointer type for logicalIfMgmt::ifAddIf operation */
typedef ix_error (* logicalIfMgmt_ifAddIf_fptr)(ix_base_t* basep, long portNum, long ifNum, const char* name, unsigned long ipV4Addr, unsigned long ipV4Mask);

/* Declare the crosscall reference function for logicalIfMgmt::ifAddIf operation */
extern ix_error stub_logicalIfMgmt_ifAddIf(ix_base_t* basep, long portNum, long ifNum, const char* name, unsigned long ipV4Addr, unsigned long ipV4Mask);

/* Declare the a cross call function pointer type for logicalIfMgmt::ifRemoveIf operation */
typedef ix_error (* logicalIfMgmt_ifRemoveIf_fptr)(ix_base_t* basep, long portNum, long ifNum, unsigned long ipV4Addr, unsigned long ipV4Mask);

/* Declare the crosscall reference function for logicalIfMgmt::ifRemoveIf operation */
extern ix_error stub_logicalIfMgmt_ifRemoveIf(ix_base_t* basep, long portNum, long ifNum, unsigned long ipV4Addr, unsigned long ipV4Mask);

/* Declare the crosscall VMT structure for logicalIfMgmt interface */

/**
 * CC_VMT_logicalIfMgmt structure holds function pointers to implementation
 * functions for all local and inherited operations
 */
typedef struct _CC_VMT_logicalIfMgmt
{
  logicalIfMgmt_ifGetIfs_fptr _pCC_logicalIfMgmt_ifGetIfs;
  logicalIfMgmt_ifGetConfig_fptr _pCC_logicalIfMgmt_ifGetConfig;
  logicalIfMgmt_ifSetConfig_fptr _pCC_logicalIfMgmt_ifSetConfig;
  logicalIfMgmt_ifSetFlags_fptr _pCC_logicalIfMgmt_ifSetFlags;
  logicalIfMgmt_ifGetFlags_fptr _pCC_logicalIfMgmt_ifGetFlags;
  logicalIfMgmt_ifAddIf_fptr _pCC_logicalIfMgmt_ifAddIf;
  logicalIfMgmt_ifRemoveIf_fptr _pCC_logicalIfMgmt_ifRemoveIf;
} CC_VMT_logicalIfMgmt;


/* Declare the callback VMT structure for logicalIfMgmt interface */

/**
 * CC_VMT_logicalIfMgmt structure holds function pointers to user callback
 * functions for all local and inherited operations
 */
typedef struct _CB_VMT_logicalIfMgmt
{
  logicalIfMgmt_ifGetIfs_cb_fptr _pCB_logicalIfMgmt_ifGetIfs;
  logicalIfMgmt_ifGetConfig_cb_fptr _pCB_logicalIfMgmt_ifGetConfig;
  logicalIfMgmt_ifGetFlags_cb_fptr _pCB_logicalIfMgmt_ifGetFlags;
} CB_VMT_logicalIfMgmt;

/* Accessor function for callback VMT */
extern ix_error getCBVMT_logicalIfMgmt(const ix_base_t* basep, CB_VMT_logicalIfMgmt** pInterfaceCBVMT);

/**=================================================
 * End stub declaration of interface logicalIfMgmt
 *================================================*/


/**=================================================
 * Start stub declaration of interface event
 *================================================*/

/* Declare the interface name for event interface */
extern const char event_intName[];

/* Declare the local operation names for CC_VMT_event interface */

/* Declare the name for event::eventRegister operation */
extern const char event_eventRegister_opName[];

/* Declare the name for event::eventUnregister operation */
extern const char event_eventUnregister_opName[];


/* Client initialization function for event interface */
extern ix_error stub_event_init (ix_base_t* basep, ix_cap *capp);

/* Client finalization function for event interface */
extern ix_error stub_event_fini (ix_base_t* basep);

/* Declare the a cross call function pointer type for event::eventRegister operation */
typedef ix_error (* event_eventRegister_fptr)(ix_base_t* basep, const char* aceName);

/* Declare the crosscall reference function for event::eventRegister operation */
extern ix_error stub_event_eventRegister(ix_base_t* basep, const char* aceName);

/* Declare the a cross call function pointer type for event::eventUnregister operation */
typedef ix_error (* event_eventUnregister_fptr)(ix_base_t* basep, const char* aceName);

/* Declare the crosscall reference function for event::eventUnregister operation */
extern ix_error stub_event_eventUnregister(ix_base_t* basep, const char* aceName);

/* Declare the crosscall VMT structure for event interface */

/**
 * CC_VMT_event structure holds function pointers to implementation
 * functions for all local and inherited operations
 */
typedef struct _CC_VMT_event
{
  event_eventRegister_fptr _pCC_event_eventRegister;
  event_eventUnregister_fptr _pCC_event_eventUnregister;
} CC_VMT_event;


/**=================================================
 * End stub declaration of interface event
 *================================================*/

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* end define */


